#
# spec file for package openafs (Version 1.4.0)
#
# Copyright (c) 2006 SUSE LINUX Products GmbH, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments via http://bugs.opensuse.org
#

# norootforbuild
# neededforbuild  heimdal heimdal-devel heimdal-lib heimdal-tools openssl-devel pam-devel

BuildRequires: aaa_base acl attr bash bind-utils bison bzip2 coreutils cpio cpp cracklib cvs cyrus-sasl db devs diffutils e2fsprogs file filesystem fillup findutils flex gawk gdbm-devel glibc glibc-devel glibc-locale gpm grep groff gzip info insserv kbd less libacl libattr libgcc libselinux libstdc++ libxcrypt m4 make man mktemp module-init-tools ncurses ncurses-devel net-tools netcfg openldap2-client openssl pam pam-modules patch permissions popt procinfo procps psmisc pwdutils rcs readline sed strace syslogd sysvinit tar tcpd texinfo timezone unzip util-linux vim zlib zlib-devel autoconf automake binutils e2fsprogs-devel gcc gdbm gettext heimdal heimdal-devel heimdal-lib heimdal-tools libtool openssl-devel pam-devel perl rpm

Name:         openafs
Version:      1.4.0
Release:      3.1
Summary:      OpenAFS distributed filesystem
License:      IBM Public License, Other License(s), see package
URL:          http://www.openafs.org/
Group:        System/Filesystems
Autoreqprov:  on
%if %suse_version > 800
PreReq:       %insserv_prereq %fillup_prereq
%endif
Source0:      openafs-%{version}-src.tar.bz2
Source10:     README.SuSE.openafs
Source11:     rc.defaultmode.afs-server
Source12:     rc.defaultmode.afs-client
Source13:     sysconfig.defaultmode.openafs-client
Source14:     rc.transarcmode.afs-server
Source15:     rc.transarcmode.afs-client
Source16:     sysconfig.transarcmode.openafs-client
Source17:     README.SuSE.openafs_spec
Source20:     Makefile
Source40:     openafs.files.defaultmode.main
Source41:     openafs.files.defaultmode.server
Source42:     openafs.files.defaultmode.client
Source43:     openafs.files.defaultmode.devel
Source50:     openafs.files.transarcmode.main
Source51:     openafs.files.transarcmode.server
Source52:     openafs.files.transarcmode.client
Source53:     openafs.files.transarcmode.devel
Source54:     openafs.CellServDB
Source55:     openafs.SuidCells
Source60:     openafs.files.km_afs
Source99:     openafs.changes
Patch1:       openafs-%{version}.layout.dif
Patch4:       openafs-%{version}-warn.patch
Patch11:      openafs-%{version}-x86_64.dif
Patch18:      openafs-%{version}-fixes.patch
Patch22:      openafs-%{version}-gcc4.patch
Patch23:      openafs-%{version}-no-kdump.patch
Patch24:      openafs-%{version}-return_value.patch
Patch25:      openafs-%{version}-printf.patch
Patch26:      openafs-%{version}-uninitialized.patch
Patch27:      openafs-%{version}-libafs.patch 
BuildRoot:    %{_tmppath}/%{name}-%{version}-build
#
#	TUNABLES
#
# 0=no krb5 | 1=(Heimdal or MIT depending on release)
%define		option_with_krb5	1
# 0=default | 1=transarc
%define		option_transarc_mode	1
# mark as made by special packager
%define		option_mark_packager	1
# clean build-root after build
%define		option_clean_buildroot	1
# don't build kdump?
# probably does not work on Linux atm.
%define		option_dontbuild_kdump	1
# build largefile fileserver
%define		option_largefile	1
#
#	GENERAL BuildRequires and Requires
#
Requires:     lsof
#
#	CHOOSE RELEASE
#
#	SLES 9
%if %{sles_version}==9
%if %{option_with_krb5}
%define		option_heimdal		1
%else
%define		option_heimdal		0
%endif
%else
#	Other (i.e. newer than SLES 9)
%define		option_heimdal		0
%if %{option_with_krb5}
Requires:     afs-krb5
%endif
%endif
#
#	MODES
#
%if %{option_transarc_mode}
#	transarc
%else
#	default
%define includedir	%{_includedir}/afs
%define afslibdir	%{_libdir}/openafs
%define afsconfdir	%{_sysconfdir}/openafs
%endif
#
#	PACKAGER - extra for packs not built by SuSE/Novell
#		   or not maintained within a distribution
#
%if %{option_mark_packager}
%endif
%package client
Summary:      OpenAFS File System Client
Group:        System/Filesystems
Requires:     openafs = %{version} kernel-nongpl
%package server
Summary:      OpenAFS filesystem server
Group:        System/Filesystems
Requires:     openafs = %{version}
%package devel
Summary:      OpenAFS static libraries and header files
Group:        Development/Libraries/Other
Requires:     openafs = %{version}
%package -n km_afs
Summary:      Sources for the OpenAFS Kernel Module
Group:        Development/Sources

%description 
AFS is a cross-platform distributed filesystem product, pioneered at
Carnegie Mellon University and supported and developed as a product by
Transarc Corporation (now IBM Pittsburgh Labs). It offers a
client-server architecture for file sharing, providing location
independence, scalability and transparent migration capabilities for
data.

In addition, among its features are authentication, encryption,
caching, disconnected operations, replication for higher availability /
load balancing, and ACLs.



Authors:
--------
    see http://www.openafs.org/credits.html


%description client
AFS is a cross-platform distributed file system product pioneered at
Carnegie Mellon University and supported and developed as a product by
Transarc Corporation (now IBM Pittsburgh Labs). It offers a
client-server architecture for file sharing, providing location
independence, scalability, and transparent migration capabilities for
data.

In addition, among its features are authentication, encryption,
caching, disconnected operations, replication for higher availability
and load balancing, and ACLs. This package contains the OpenAFS client.

Authors:
--------
    see http://www.openafs.org/credits.html


%description server
AFS is a cross-platform distributed filesystem product, pioneered at
Carnegie Mellon University and supported and developed as a product by
Transarc Corporation (now IBM Pittsburgh Labs). It offers a
client-server architecture for file sharing, providing location
independence, scalability and transparent migration capabilities for
data.

In addition, among its features are authentication, encryption,
caching, disconnected operations, replication for higher availability /
load balancing, and ACLs.

This package contains the OpenAFS server.



Authors:
--------
    see http://www.openafs.org/credits.html


%description devel
AFS is a cross-platform distributed filesystem product, pioneered at
Carnegie Mellon University and supported and developed as a product by
Transarc Corporation (now IBM Pittsburgh Labs). It offers a
client-server architecture for file sharing, providing location
independence, scalability and transparent migration capabilities for
data.

In addition, among its features are authentication, encryption,
caching, disconnected operations, replication for higher availability /
load balancing, and ACLs.

This package contains the static libraries and header files, needed to
develop applications for OpenAFS.



Authors:
--------
    see http://www.openafs.org/credits.html


%description -n km_afs
This package contains the sources for the OpenAFS kernel module.

Authors:
--------
    see http://www.openafs.org/credits.html

%prep
%setup -q 
cp src/config/param.ppc64_linux24.h src/config/param.ppc64_linux26.h
cp src/config/param.s390_linux24.h src/config/param.s390_linux26.h
#
%if %{option_transarc_mode} 
%else
%patch1 -p1
%endif
#
%patch4
%patch11
%patch18
%patch22
#
%if %{option_dontbuild_kdump}
%patch23
%endif
#
%patch24
%patch25
%patch26
%patch27
./regen.sh
#perl -pi -e 's,/lib/,/%_lib/,g' $(find src/config -name "Makefile.*linux*.in")
#perl -pi -e 's,^(XCFLAGS.*),\1 -fno-strict-aliasing,' $(find src/config -name "Makefile.*linux*.in")

%build
sysbase=%{_arch}
%ifarch %ix86
	sysbase=i386
%endif
%ifarch ppc
	perl -pi -e 's,^(XCFLAGS.*),\1 -fPIC,' src/config/Makefile.ppc_linux24.in
%endif
%ifarch ppc64
	sysbase=ppc64
%endif
%ifarch s390x
	sysbase=s390
%endif
%ifarch x86_64
	sysbase=amd64
	perl -pi -e 's,^(XCFLAGS.*),\1 -fPIC,' src/config/Makefile.amd64_linux24.in
	perl -pi -e 's,^(XLIBS.*),\1 -lresolv,' src/config/Makefile.amd64_linux24.in
%endif
afs_sysname=${sysbase}_linux26
# there are mixed static and shared libs, using -fPIC everywhere is the most safe.
#
%if %{option_heimdal}
export CFLAGS="$RPM_OPT_FLAGS -fno-strict-aliasing -fPIC -I/usr/include/heimdal" 
%else
export CFLAGS="$RPM_OPT_FLAGS -fno-strict-aliasing -fPIC" 
%endif
#
./configure \
		--prefix=/usr \
%if %{option_transarc_mode}
		--enable-transarc-paths \
%else
		--disable-transarc-paths \
		--bindir=%{_bindir} \
		--sbindir=%{_sbindir} \
		--libdir=%{_libdir} \
		--libexecdir=%{_libdir} \
		--includedir=%{includedir} \
		--sysconfdir=%{_sysconfdir} \
		--mandir=%{_mandir} \
%endif
%if %{option_heimdal}
		--with-krb5-conf=/usr/lib/heimdal/bin/krb5-config \
%endif
%if %{option_largefile}
		--enable-largefile-fileserver \
%endif
		--with-afs-sysname=$afs_sysname
#
make CCFLAGS="$CFLAGS" XCFLAGS="$CFLAGS" PAM_CFLAGS="$CFLAGS" KOPTS="$CFLAGS" all_nolibafs 
make CCFLAGS="$CFLAGS" XCFLAGS="$CFLAGS" PAM_CFLAGS="$CFLAGS" KOPTS="$CFLAGS" only_libafs_tree
# the test suite need a configured KDC
#make -C src/tests all

%install
if [ -n "$RPM_BUILD_ROOT" ] ; then
   [ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT
fi
#	copy file-lists before modifying
cp -a %{S:40} %{S:41} %{S:42} %{S:43} %{S:50} %{S:51} %{S:52} %{S:53} %{S:60} .
#
mkdir -p ${RPM_BUILD_ROOT}
#
%if %{option_transarc_mode}
make DESTDIR=${RPM_BUILD_ROOT} install_nolibafs
mkdir -p ${RPM_BUILD_ROOT}/usr/afs/logs
mkdir -p ${RPM_BUILD_ROOT}/usr/afs/local
mkdir -p ${RPM_BUILD_ROOT}/usr/afs/db
mkdir -p ${RPM_BUILD_ROOT}/usr/vice/etc
mkdir -p ${RPM_BUILD_ROOT}/usr/vice/cache
#
install %{S:54} ${RPM_BUILD_ROOT}/usr/vice/etc/CellServDB
install %{S:55} ${RPM_BUILD_ROOT}/usr/vice/etc/SuidCells
touch ${RPM_BUILD_ROOT}/usr/vice/etc/ThisCell
touch ${RPM_BUILD_ROOT}/usr/vice/etc/cacheinfo
# config & startup files
mkdir -p $RPM_BUILD_ROOT/etc/init.d
install -m 755 $RPM_SOURCE_DIR/rc.transarcmode.afs-server $RPM_BUILD_ROOT/etc/init.d/openafs-fileserver
install -m 755 $RPM_SOURCE_DIR/rc.transarcmode.afs-client $RPM_BUILD_ROOT/etc/init.d/openafs-client
ln -s ../../etc/init.d/openafs-fileserver $RPM_BUILD_ROOT/usr/sbin/rcopenafs-fileserver
ln -s ../../etc/init.d/openafs-client $RPM_BUILD_ROOT/usr/sbin/rcopenafs-client
# 	fix lib64
%if "%{_lib}" == "lib64"
mv $RPM_BUILD_ROOT/usr/lib	$RPM_BUILD_ROOT/usr/%{_lib}
%endif
#
%else
#	default-mode
mkdir -p $RPM_BUILD_ROOT/%{afsconfdir}
mkdir -p $RPM_BUILD_ROOT/%{_libdir}/
mkdir -p $RPM_BUILD_ROOT/%{_prefix}/include
make DESTDIR=$RPM_BUILD_ROOT install_nolibafs
# config & startup files
mkdir -p $RPM_BUILD_ROOT/etc/init.d
install -m 755 $RPM_SOURCE_DIR/rc.defaultmode.afs-server $RPM_BUILD_ROOT/etc/init.d/openafs-fileserver
install -m 755 $RPM_SOURCE_DIR/rc.defaultmode.afs-client $RPM_BUILD_ROOT/etc/init.d/openafs-client
ln -s ../../etc/init.d/openafs-fileserver $RPM_BUILD_ROOT/usr/sbin/rcopenafs-fileserver
ln -s ../../etc/init.d/openafs-client $RPM_BUILD_ROOT/usr/sbin/rcopenafs-client
mkdir -p $RPM_BUILD_ROOT/var/log/openafs
%endif
#
#	common: pam, manpages, kpasswd
mkdir -p $RPM_BUILD_ROOT/%{_mandir}/man1
install -m 644 src/man/* $RPM_BUILD_ROOT/%{_mandir}/man1
# conflicts with kpasswd from heimdal package
mv $RPM_BUILD_ROOT/usr/bin/kpasswd $RPM_BUILD_ROOT/usr/bin/kpasswd.afs
mv $RPM_BUILD_ROOT/%{_mandir}/man1/kpasswd.1 $RPM_BUILD_ROOT/%{_mandir}/man1/kpasswd.afs.1
mkdir -p %{buildroot}/%{_lib}/security/
#mv %{buildroot}/%{_libdir}/pam_afs.so.1 	/%{_lib}/security/pam_afs.so
#mv %{buildroot}/%{_libdir}/pam_afs.krb.so.1 	/%{_lib}/security/pam_afs.krb.so
mv %{buildroot}/%{_libdir}/pam* %{buildroot}/%{_lib}/security/
ln -sf pam_afs.so.1	%{buildroot}/%{_lib}/security/pam_afs.so
ln -sf pam_afs.krb.so.1	%{buildroot}/%{_lib}/security/pam_afs.krb.so
#	common: km_afs - kernel module subpackage
mkdir -p $RPM_BUILD_ROOT/usr/src/kernel-modules/openafs
chmod -R o-w src/libafs
chmod -R o-w libafs_tree
# hack, patch generated files
cp -a libafs_tree $RPM_BUILD_ROOT/usr/src/kernel-modules/openafs
cp -av %{S:20} $RPM_BUILD_ROOT/usr/src/kernel-modules/openafs/
install -m 644 src/LICENSE $RPM_BUILD_ROOT/usr/src/kernel-modules/openafs/LICENSE
#
mkdir -p $RPM_BUILD_ROOT/%{_mandir}/man5
install -m 644 src/pam/pam_afs.5 $RPM_BUILD_ROOT/%{_mandir}/man5
cp %{S:10} README.SuSE
cp %{S:17} README.SuSE.openafs_spec
#
#conflict with e2fsprogs-devel
mv $RPM_BUILD_ROOT/usr/bin/compile_et $RPM_BUILD_ROOT/usr/bin/compile_et.afs
#
%if %{option_transarc_mode}
mkdir -p $RPM_BUILD_ROOT/var/adm/fillup-templates
install -m 644 %{S:16} $RPM_BUILD_ROOT/var/adm/fillup-templates/sysconfig.openafs-client
#	everybody does, but is this correct? So, we copy, don't move!
cp -a $RPM_BUILD_ROOT/usr/sbin/afsd $RPM_BUILD_ROOT/usr/vice/etc/afsd
%if %{option_heimdal}
echo /usr/bin/aklog  >> openafs.files.transarcmode.client
%endif
#
%else
#       default-mode
mkdir -p $RPM_BUILD_ROOT/var/adm/fillup-templates
install -m 644 %{S:13} $RPM_BUILD_ROOT/var/adm/fillup-templates/sysconfig.openafs-client
#
mkdir -p $RPM_BUILD_ROOT/var/cache/openafs
mkdir -p $RPM_BUILD_ROOT/afs
mkdir -p $RPM_BUILD_ROOT/etc/openafs
mkdir -p $RPM_BUILD_ROOT/var/lib/openafs
# it's already in /usr/bin
rm -f $RPM_BUILD_ROOT/usr/sbin/kpwvalid
# we supposedly don't need this one on linux
rm -f $RPM_BUILD_ROOT/usr/sbin/rmtsysd
#
%if %{option_dontbuild_kdump}
rm -f $RPM_BUILD_ROOT/usr/sbin/kdump
%else
echo /usr/sbin/kdump >> openafs.files.defaultmode.main
%endif
#
%if %{option_heimdal}
echo /usr/bin/aklog  >> openafs.files.defaultmode.client
%endif
#
# since currently everything is linked statically, we can discard the shared objects:
rm -f $RPM_BUILD_ROOT/usr/%_lib/*.so
rm -f $RPM_BUILD_ROOT/usr/%_lib/*.so.*
#
%endif
#

%clean
%if %{option_clean_buildroot}
if [ -n "$RPM_BUILD_ROOT" ] ; then
	[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT
fi
%endif

%post client
if [ -f etc/sysconfig/afs-client -a ! -f etc/sysconfig/openafs-client ]; then
  mv etc/sysconfig/afs-client etc/sysconfig/openafs-client
fi
%{fillup_and_insserv -n openafs-client}

%postun client
%{insserv_cleanup}

%postun server
%{insserv_cleanup}
#
#	FILES
#
%if %{option_transarc_mode}
#

%files           -f openafs.files.transarcmode.main

%files    server -f openafs.files.transarcmode.server

%files    client -f openafs.files.transarcmode.client

%files    devel  -f openafs.files.transarcmode.devel
%else
#       default-mode

%files           -f openafs.files.defaultmode.main

%files    server -f openafs.files.defaultmode.server

%files    client -f openafs.files.defaultmode.client

%files    devel  -f openafs.files.defaultmode.devel
#
%endif
#       km_afs - kernel module subpackage

%files -n km_afs -f openafs.files.km_afs
#
#	CHANGELOG
#

%changelog -n openafs
* Wed Jan 11 2006 - mge@suse.de
- add openafs.SuidCells and openafs.CellServDB
- cleanup SPEC-file(s)
- finally adopt
  sysconfig.transarcmode.openafs-client
  rc.transarcmode.afs-server
  rc.transarcmode.afs-client
  to transarc mode; and fix a small typo in
  rc.defaultmode.afs-client
* Fri Jan 06 2006 - mge@suse.de
- set "%%defattr(-,root,root)" for transarcmode-file-lists
- fix lib64 build problem in transarcmode
* Thu Jan 05 2006 - mge@suse.de
- introduce transarc-mode and default-mode
- introduce "options"
* Thu Dec 29 2005 - mge@suse.de
- build for SLES 9
- with heimdal krb5 support
- enable-largefile-fileserver
* Wed Dec 21 2005 - nadvornik@suse.cz
- updated to 1.4.0
- fixed dangerous compiler warnings
* Mon Oct 31 2005 - dmueller@suse.de
- don't build as root
* Fri Aug 26 2005 - nadvornik@suse.cz
- fixed kernel module to build
- fixed sysconfig file name
* Thu Jul 14 2005 - nadvornik@suse.cz
- updated to 1.3.85
- used LSB conforming init script names
* Tue Jul 05 2005 - hare@suse.de
- Update for linux 2.6.13.
* Thu May 12 2005 - nadvornik@suse.cz
- gcc4 fixes in kernel module
* Tue Apr 12 2005 - nadvornik@suse.cz
- fixed to compile with gcc4
* Wed Feb 23 2005 - nadvornik@suse.cz
- fixed memory leaks and 64bit fixes backported from 1.3.79
- updated README.SUSE
* Thu Feb 03 2005 - nadvornik@suse.cz
- updated to 1.3.78
* Mon Jan 31 2005 - nadvornik@suse.cz
- fixed afs.h to be usable from userspace [#50283]
* Tue Jan 25 2005 - nadvornik@suse.cz
- updated to latest snapshot
* Wed Sep 15 2004 - nadvornik@suse.cz
- added requres: kernel-nongpl [#45167]
- fixed kernel module oops [#44618]
* Wed Aug 11 2004 - nadvornik@suse.cz
- use kernel module from openafs 1.3.70 to support kernel 2.6
* Mon Mar 08 2004 - nadvornik@suse.cz
- updated to 1.2.11
- added note that client for kernel 2.6 is not available
* Tue Jan 20 2004 - ro@suse.de
- added pam-devel to neededforbuild
* Sat Dec 13 2003 - meissner@suse.de
- Added hack if no MTU came from userspace.
- Removed superflous ppc64 patch part.
* Thu Dec 11 2003 - meissner@suse.de
- ppc64 port added (status: no longer crashes, talks to the network,
  but not successfully).
- Change headerfiles to make it possible to do a ppc -> ppc64 crosscompile.
* Mon Oct 06 2003 - olh@suse.de
- build with -fPIC on ppc32
* Tue Sep 16 2003 - nadvornik@suse.cz
- patch from cvs to use AllocLargeSpace for struct osi_file to prevent
  oopses with some kernel configurations
* Thu Sep 11 2003 - nadvornik@suse.cz
- added option DYNROOT to sysconfig and enabled it by default [#27205]
* Wed Sep 10 2003 - nadvornik@suse.cz
- added cleanup before module build [#29649]
* Tue Sep 09 2003 - nadvornik@suse.cz
- fixed possible segfault
* Thu Sep 04 2003 - nadvornik@suse.cz
- set permissions of /var/lib/openafs to 700
- README.SuSE fixes
* Thu Aug 28 2003 - nadvornik@suse.cz
- use ghost for /afs, the directory is created by init-script
- fixed README.SuSE
* Thu Aug 21 2003 - nadvornik@suse.cz
- moved all static libraries to /usr/lib/afs, fixes conflict with libdes
- used default value for THIS_CELL_SERVER_NAME
- removed old patches
* Tue Aug 12 2003 - nadvornik@suse.cz
- fixed a bug in init script
* Mon Aug 11 2003 - nadvornik@suse.cz
- updated to final 1.2.10
* Wed Jul 30 2003 - nadvornik@suse.cz
- updated to 1.2.10-rc4
- do not destroy CellServDB even if REGENERATE_CELL_INFO=yes
- fixed to compile on x86_64
* Wed Jul 30 2003 - sf@suse.de
-  use %%_lib where it was missing
* Wed Jul 09 2003 - nadvornik@suse.cz
- fixed conflicts in filelist
* Fri Jun 20 2003 - nadvornik@suse.cz
- improved init scripts
* Thu Jun 19 2003 - nadvornik@suse.cz
- added README.SuSE
- fixed init scripts [#27426]
- installed man pages
* Thu Jun 12 2003 - poeml@suse.de
- add /usr/src/kernel-modules to the file list
* Wed Jun 04 2003 - schwab@suse.de
- Fix SMP configuration detection.
* Wed May 14 2003 - poeml@suse.de
- rework filelists:
- package/remove unpackaged files
- move some files into the server & client subpackages
- use %%defattr
- fix deprecated tail -1 syntax (fixes building the kernel module)
* Mon May 12 2003 - nadvornik@suse.cz
- updated to 1.2.9
- added DATA_ENCRYPTION option to sysconfig
* Mon Mar 10 2003 - poeml@suse.de
- x86_64: add -lresolv, -fPIC
- fix lib path on all 64 bit platforms
* Thu Mar 06 2003 - nadvornik@suse.cz
- added sysconfig metadata
* Mon Feb 24 2003 - nadvornik@suse.cz
- added dirs /afs, /etc/openafs, /var/lib/openafs to filelist
* Sun Feb 16 2003 - olh@suse.de
- workaround broken -lresolv detection, lib64 fixes
* Wed Feb 12 2003 - nadvornik@suse.cz
- fixed multiline strings in kernel module
* Fri Jan 24 2003 - nadvornik@suse.cz
- updated to 1.2.8
- improved init script
* Fri Nov 29 2002 - nadvornik@suse.cz
- included errno.h
- fixed multiline strings
* Fri Nov 22 2002 - nadvornik@suse.cz
- first version of init scripts
* Wed Nov 20 2002 - poeml@suse.de
- initial draft of a package. Lots of stuff missing, like init
  scripts, or the kerberos 5 migration toolkit.
